=== pybindgen-0.14.1/examples/wscript ===
## -*- python -*-

def build(bld):
    bld.add_subdirs('a b c d e f g h')
