=== ns-3.8/src/common/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def build(bld):
    common = bld.create_ns3_module('common', ['core', 'simulator'])
    common.source = [
        'buffer.cc',
        'packet-metadata.cc',
        'packet-metadata-test.cc',
        'packet.cc',
        'chunk.cc',
        'header.cc',
        'trailer.cc',
        'data-rate.cc',
        'error-model.cc',
        'tag.cc',
        'byte-tag-list.cc',
        'tag-buffer.cc',
        'packet-tag-list.cc',
        'nix-vector.cc',
        'pcap-file.cc',
        'pcap-file-test-suite.cc',
        'pcap-file-wrapper.cc',
        'output-stream-wrapper.cc',
        'propagation-delay-model.cc',
        'propagation-loss-model.cc',
        'propagation-loss-model-test-suite.cc',
        'jakes-propagation-loss-model.cc',
        'cost231-propagation-loss-model.cc',
        ]

    headers = bld.new_task_gen('ns3header')
    headers.module = 'common'
    headers.source = [
        'buffer.h',
        'chunk.h',
        'header.h',
        'trailer.h',
        'packet.h',
        'packet-metadata.h',
        'data-rate.h',
        'error-model.h',
        'tag.h',
        'byte-tag-list.h',
        'tag-buffer.h',
        'packet-tag-list.h',
        'nix-vector.h',
        'sgi-hashmap.h',
        'pcap-file.h',
        'pcap-file-wrapper.h',
        'output-stream-wrapper.h',
        'propagation-delay-model.h',
        'propagation-loss-model.h',
        'jakes-propagation-loss-model.h',
        'cost231-propagation-loss-model.h',
        ]
