=== ns-3.8/src/node/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def build(bld):
    node = bld.create_ns3_module('node', ['core', 'common', 'simulator'])
    node.source = [
        'address.cc',
        'mac48-address.cc',
        'mac64-address.cc',
        'inet-socket-address.cc',
        'packet-socket-address.cc',
        'node.cc',
        'ipv4-address.cc',
        'ipv4-interface-address.cc',
        'ipv4-address-generator.cc',
        'ipv4-header.cc',
        'net-device.cc',
	'address-utils.cc',
        'llc-snap-header.cc',
        'ethernet-header.cc',
        'ethernet-trailer.cc',
        'ipv4-route.cc',
        'ipv4-routing-protocol.cc',
        'queue.cc',
        'drop-tail-queue.cc',
        'channel.cc',
        'node-list.cc',
        'channel-list.cc',
        'socket.cc',
        'socket-factory.cc',
        'packet-socket-factory.cc',
        'packet-socket.cc',
        'udp-socket.cc',
        'udp-socket-factory.cc',
        'tcp-socket.cc',
        'tcp-socket-factory.cc',
        'ipv4.cc',
        'ipv4-raw-socket-factory.cc',
        'application.cc',
        'simple-channel.cc',
        'simple-net-device.cc',
        'inet6-socket-address.cc',
        'ipv6-address.cc',
        'ipv6-header.cc',
        'ipv6-interface-address.cc',
        'ipv6-route.cc',
        'ipv6.cc',
        'ipv6-raw-socket-factory.cc',
        'ipv6-routing-protocol.cc',
        'packetbb.cc',
        'packetbb-test-suite.cc',
        'radiotap-header.cc',
        ]

    headers = bld.new_task_gen('ns3header')
    headers.module = 'node'
    headers.source = [
        'address.h',
        'mac48-address.h',
        'mac64-address.h',
        'inet-socket-address.h',
        'packet-socket-address.h',
        'node.h',
        'ipv4-address.h',
        'ipv4-interface-address.h',
        'ipv4-address-generator.h',
        'ipv4-header.h',
        'net-device.h',
      	'address-utils.h',
        'ipv4-route.h',
        'ipv4-routing-protocol.h',
        'queue.h',
        'drop-tail-queue.h',
        'llc-snap-header.h',
        'ethernet-header.h',
        'ethernet-trailer.h',
        'channel.h',
        'node-list.h',
        'channel-list.h',
        'socket.h',
        'socket-factory.h',
        'packet-socket-factory.h',
        'udp-socket.h',
        'udp-socket-factory.h',
        'tcp-socket.h',
        'tcp-socket-factory.h',
        'ipv4.h',
        'ipv4-raw-socket-factory.h',
        'application.h',
        'simple-channel.h',
        'simple-net-device.h',
        'inet6-socket-address.h',
        'ipv6-address.h',
        'ipv6-header.h',
        'ipv6-interface-address.h',
        'ipv6-route.h',
        'ipv6.h',
        'ipv6-raw-socket-factory.h',
        'ipv6-routing-protocol.h',
        'packetbb.h',
        'radiotap-header.h',
        ]
