=== pybindgen-0.14.1/examples/c/wscript ===
## -*- python -*-

def build(bld):

    gen = bld.new_task_gen(
        features='command',
        source='modulegen.py',
        target='cmodule.cc',
        command='${PYTHON} ${SRC[0]} > ${TGT[0]}')

    if bld.env['CXX']:
        obj = bld.new_task_gen('cxx', 'shlib', 'pyext')
        obj.source = [
            'c.cc',
            'cmodule.cc'
            ]
        obj.target = 'c'
        obj.install_path = None # do not install
        obj.includes = '.'
