=== ns-3.8/src/devices/mesh/wscript ===
## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-

def build(bld):
    obj = bld.create_ns3_module('mesh', ['wifi'])

    obj.source = [
        'wifi-information-element-vector.cc',
        'mesh-point-device.cc',
        'mesh-l2-routing-protocol.cc',
        'mesh-wifi-beacon.cc',
        'mesh-wifi-interface-mac.cc',
        ]
    headers = bld.new_task_gen('ns3header')
    headers.module = 'mesh'
    headers.source = [
        'wifi-information-element-vector.h',
        'mesh-point-device.h',
        'mesh-l2-routing-protocol.h',
        'mesh-wifi-beacon.h',
        'mesh-wifi-interface-mac.h',
        'mesh-wifi-interface-mac-plugin.h',
        ]
