=== debian/changelog ===
ns3 (3.8-3) unstable; urgency=low

  * Open debug and fix Bug#582926 :Possible uses -march=native
  * fix python-ns3
  * add build dep libxml2-dev libgsl0-dev

 -- YunQiang Su <wzssyqa@gmail.com>  May, 21 Sun 2010 20:09:10 +0800

ns3 (3.8-2) unstable; urgency=low

  * Some arch have no libopenmpi-dev,so remove it on these arch
  * add override_auto_clean

 -- YunQiang Su <wzssyqa@gmail.com>  May, 19 Sun 2010 15:09:10 +0800

ns3 (3.8-1) unstable; urgency=low

  * New Upstream version

 -- YunQiang Su <wzssyqa@gmail.com>  May, 9 Sun 2010 12:22:35 +0800
